unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CommHandle : hFile;
  DCB : TDCB;
  PortString: string;
  CommTimeOuts: TCOMMTIMEOUTS;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
PortString := '\\.\COM' + Edit1.Text;   
CommHandle := CreateFile(PChar(PortString), GENERIC_READ or GENERIC_WRITE, 0, nil, OPEN_EXISTING,
         0, 0);

if (CommHandle = INVALID_HANDLE_VALUE) then
begin
  MessageDlg('Error. Can`t Open port', mtError, [mbOK], 0);
end
else
begin
  GetCommState(CommHandle, DCB);
  DCB.BaudRate  := CBR_9600; // FORMALLY, CONNECT BAUD DOESN`T MATTER (Virtual Com Port)
  DCB.Parity    := NOPARITY;
  DCB.ByteSize  := 8;
  DCB.StopBits  := OneStopBit;   

  CommTimeOuts.ReadIntervalTimeout          := 0;
  CommTimeOuts.ReadTotalTimeoutMultiplier   := 0;
  CommTimeOuts.ReadTotalTimeoutConstant     := 1000;
  CommTimeOuts.WriteTotalTimeoutMultiplier  := 0;
  CommTimeOuts.WriteTotalTimeoutConstant    := 1000;
  SetCommTimeouts(CommHandle, CommTimeOuts);
  SetCommState(CommHandle, DCB);

  MessageDlg('Port Open Ok', mtInformation, [mbOK], 0);
end
end;

procedure TForm1.Button2Click(Sender: TObject);
var
Line: Byte;
Value: Byte;
BinBuf: array[0..1023] of Char;
Buf: string;
CRbyte: Shortint;
LFbyte: Shortint;
NumberWritten : DWORD;
begin
CRbyte := 13; // HEX 0x0D
LFbyte := 10; // HEX 0x0A

Line := StrToInt(Edit2.Text);
if ((Line < 0) or (Line > 24)) then
begin
  MessageDlg('Invalid Line Number', mtError, [mbOK], 0);
  Exit;
end;

//**********************************************************

Buf := '$KE,RD,' + Edit2.Text + Char(CRbyte) + Char(LFbyte);
WriteFile(CommHandle, PChar(Buf)^, Length(Buf), NumberWritten, nil);

// Make littele pause for wait module anser
Sleep(20); // Wait 20 ms

ReadFile(CommHandle, BinBuf, 128, NumberWritten, nil);
if(NumberWritten = 0) then
begin
  MessageDlg('Reaf Line Fail #1', mtError, [mbOK], 0);
  Exit;
end;

// We have read some data from port. Let`s try to parse it
if(StrLComp(BinBuf, '#RD,WRONGLINE', 13) = 0) then
begin
  MessageDlg('This line setup as OUTPUT. Can`t read data.', mtError, [mbOK], 0);
  Exit;
end;

// We must get anser like this: #RD,<LineNumber>,<Value>
Buf := Format('#RD,%.2d,', [Line]);
if(StrLComp(BinBuf, PChar(Buf), Length(Buf)) = 0) then
begin
  Value := Byte(BinBuf[Length(Buf)]) - $30;
  if((Value < 0) or (Value > 1) ) then
  begin
    MessageDlg('Reaf Line Fail #3', mtError, [mbOK], 0);
    Exit;
  end;
  Buf := Format('Line: %d Value: %d', [Line, Value]);
  MessageDlg(Buf, mtInformation, [mbOK], 0);
  Exit;
end
else
begin
  MessageDlg('Reaf Line Fail #2', mtError, [mbOK], 0);
  Exit;
end;

//*************************************************************


end;

end.
